--The database to apply the next SQL commands on. Change to your DB name
USE CompanyDBLab7; -- The DB we created in Lab6
GO

-- Note: If you do not already have this DB, you can use script CompanyDBLab4

---------------------------------------------------------------------------------------------
---------------------------------- Example1: SimpleProc -------------------------------------
---------------------------------------------------------------------------------------------
-- It has no input nor output prameters 
-- Similar to void f( ) in C++

CREATE PROCEDURE SimpleProc
AS
BEGIN
SELECT * FROM Employee
END
GO
------------------------------------------
-- To call the procedure
EXEC SimpleProc
GO

---------------------------------------------------------------------------------------------
---------------------------------- Example2: InputParamProc ---------------------------------
---------------------------------------------------------------------------------------------
-- Procedure with input parameters. 
-- Similar to void f(int Department_number) in C++
-- input parameter name: @Department_number, type int
CREATE PROCEDURE InputParamProc @Department_number int
AS
BEGIN
SELECT Fname,Lname
FROM Employee
WHERE Dno = @Department_number
END
GO
------------------------------------------
-- To call the procedure 
EXEC InputParamProc @Department_number = 5
-- OR Simply
EXEC InputParamProc  5
GO

---------------------------------------------------------------------------------------------
---------------------------------- Example3: InOutProc --------------------------------------
---------------------------------------------------------------------------------------------
-- Procedure with both input and output parameters. 
-- Similar to void f(int Department_number, int & EmpCnt) in C++
-- input parameter name: @Department_number, type int
-- Output parameter (is like pass by ref in C++). Parameter name: @EmpCnt, type int

CREATE PROCEDURE InOutProc @Department_number int, @EmpCnt int OUTPUT
AS
BEGIN
SELECT @EmpCnt = count(*) 
FROM Employee
WHERE Dno = @Department_number
END
GO
-----------------------------------------
-- To call the procedure
DECLARE @EmployeesCount int	-- Declare var to store proc result (to pass it by ref)
DECLARE @Dno int = 5		-- Declare input param

EXEC InOutProc @Dno, @EmployeesCount OUTPUT  -- Call the proc

SELECT @EmployeesCount  -- Print the value of @EmployeesCount var after calling
-- OR simply
EXEC InOutProc 5, @EmployeesCount OUTPUT

SELECT @EmployeesCount  -- Print the value of @EmployeesCount var
-- Another way to print meaningful output. Notice how vars are converted to strings to be printed
SELECT 'No. of Employees in Department ' + CONVERT (varchar(3), @Dno) + ' is ' +  CONVERT (varchar(8), @EmployeesCount)
GO


---------------------------------------------------------------------------------------------
---------------------------------- Example4: RetProc --------------------------------------
---------------------------------------------------------------------------------------------
-- A procedure that returns a value
-- Similar to int f(int SSN) in C++
-- input parameter name: @SSN, type int

CREATE PROCEDURE RetProc @SSN int
AS 
IF (SELECT Super_SSN
FROM Employee
where SSN=@SSN) IS NULL
Return 0
else
Return 1
GO
-----------------------------------------
-- To call the procedure
DECLARE  @R INT

EXEC @R = RetProc 123456789 -- Cal the proc, pass value to it and store it return in var @R 

SELECT 'Procedure returns '  + CONVERT(varchar(10), @R)

GO
-----------------------------------------